#include <ncbi.h>
#include <dfa.h>

/*************************************************************************
 * dfa_extent(dp)
 *
 *	Return the no. of bytes of storage allocated to the DFA.
 *
 *	Returns 0 upon error, and sets dfaerrno = the error encountered.
 *************************************************************************/
unsigned long _cdecl
dfa_extent(dp)
	register DFAPtr	dp;
{
	register DFA_BufPtr	bp;
	register unsigned long	totbytes = 0;

	if (dp == NULL || dp->magic != DFA_MAGIC) {
		dfaerrno = dfaErrBadPtr;
		return 0;
	}

	if (dp->opstate < dfaOpstateMemInit || dp->opstate >= dfaOpstateDestroyed) {
		dfaerrno = dfaErrOpstate;
		return 0;
	}

	bp = &dp->buf0;
	while (bp != NULL) {
		totbytes += bp->bsize;
		bp = bp->chain;
	}
	return totbytes;
}
