#include <ncbi.h>
#include <gishlib.h>

/*
	Return values accurate to approx. 16 digits for the quantity exp(x)-1
	for all values of x, both large and small.
*/
double LIBCALL
fct_expm1(x)
	double	x;
{
	double	absx;

	if ((absx = ABS(x)) > .33)
		return exp(x) - 1.;

	if (absx < 1.e-16)
		return x;

	return x * (1. + x *
					(0.5 + x * (1./6. + x *
						(1./24. + x * (1./120. + x *
							(1./720. + x * (1./5040. + x *
								(1./40320. + x * (1./362880. + x *
									(1./3628800. + x * (1./39916800. + x *
										(1./479001600. + x/6227020800.)
									))
								))
							))
						))
					)));
}
